//+----------------------------------------------------------------------------+
//|                                                         e-MovingInWL2.mq4  |
//|                                                                            |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  27.10.2008      .                         |
//+----------------------------------------------------------------------------+
#property copyright "Kim Igor V. aka KimIV"
#property link      "http://www.kimiv.ru"

extern string     i5 = " ";                            //|----------------->
extern double     lotW                       = 0.1;                     // 
extern double     lotProc                    = 1.0;                     //   
extern string     i6 = "";                                        //|----------------->
extern bool       useMart                    = false;                   // 
extern double     kLotUb                     = 2.0;                     //   
extern double     lotMax                     = 5.0;                     // 
extern bool       useCloseSignal             = true;                    //  
extern int        Stoploss3                  = 0;                       //-
extern string     i4 = " ";                               //|----------------->
extern int        slip                       = 2;                       //
extern int        magic                      = 7037;                    // 

//-------    -----------------------------------------+
extern string _P_Expert = "----------  ";
extern bool   AllSymbols  = True;      //     
extern int    LevelProfit = 25;        //    
extern int    LevelWLoss  = 1;         //    
extern bool   ShowComment = True;      //  

//-------     ------------------------------+
extern string _P_Performance = "----------  ";
extern bool   UseSound     = False;          //   
extern string SoundSuccess = "expert.wav";  //  
extern string SoundError   = "timeout.wav"; //  
extern int    NumberOfTry  = 2;             //   

//-------    -------------------------------------+
bool   gbDisabled   = False;           //   
bool   gbNoInit     = False;           //   
color  clModifyBuy  = Aqua;            //    
color  clModifySell = Tomato;          //    

//-------    -----------------------------------------+
#include <stdlib.mqh>
int      typeOpen=-1;
double   openPrice=0,openLots=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit(){
   int pm=1;
   if (Digits == 3 || Digits == 5) pm = 10;
   slip*=pm;
   Stoploss3*=pm;
   ChartSetInteger(0,CHART_SHOW_GRID,0);
   
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){
   Comment("");
}
//+------------------------------------------------------------------+*/
void OnTick(){
   if (CountPos(magic)==1 && CountPos(magic+1)==0){
      if (useCloseSignal){
   double MA1=iMA(NULL,0,7,0,MODE_SMMA,PRICE_MEDIAN,1);
   double MA2=iMA(NULL,0,7,0,MODE_SMMA,PRICE_MEDIAN,2);
   double MA01=iMA(NULL,0,14,0,MODE_SMMA,PRICE_MEDIAN,1);
   double MA02=iMA(NULL,0,14,0,MODE_SMMA,PRICE_MEDIAN,2); 
         if((typeOpen==OP_BUY && (MA02>MA2 && MA01<MA1)) || (typeOpen==OP_SELL && (MA02<MA2 && MA01>MA1)))
         {
            CloseAll();
            openPrice=0; 
            typeOpen=0;
            return;
         }
      }   
   }
 }
//+----------------------------------------------------------------------------+
//|                                                                            |
//|                                                     |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 18.07.2008                                                     |
//|   :        .      |
//+----------------------------------------------------------------------------+
color IIFc(bool condition, color ifTrue, color ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.02.2008                                                     |
//|   :        .      |
//+----------------------------------------------------------------------------+
string IIFs(bool condition, string ifTrue, string ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  color  cl=IIFc(OrderType()==OP_BUY
              || OrderType()==OP_BUYLIMIT
              || OrderType()==OP_BUYSTOP, clModifyBuy, clModifySell);
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        er=GetLastError();
        if (UseSound) PlaySound(SoundError);
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 23.04.2009                                                     |
//|   :                                    |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     ( ""  -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    ( -1  -  )                  |
//|    mn - MagicNumber                ( -1  -  )                    |
//+----------------------------------------------------------------------------+
void MovingInWL(string sy="", int op=-1, int mn=-1) {
  double po, pp;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          po=MarketInfo(OrderSymbol(), MODE_POINT);
          if (OrderType()==OP_BUY) {
            if (OrderStopLoss()-OrderOpenPrice()<LevelWLoss*po) {
              pp=MarketInfo(OrderSymbol(), MODE_BID);
              if (pp-OrderOpenPrice()>LevelProfit*po) {
                ModifyOrder(-1, OrderOpenPrice()+LevelWLoss*po, -1);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            if (OrderStopLoss()==0 || OrderOpenPrice()-OrderStopLoss()<LevelWLoss*po) {
              pp=MarketInfo(OrderSymbol(), MODE_ASK);
              if (OrderOpenPrice()-pp>LevelProfit*po) {
                ModifyOrder(-1, OrderOpenPrice()-LevelWLoss*po, -1);
              }
            }
          }
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+
//+--------------------------------------------------------------------+
//|   :        -1.   

int NumberOfBarCloseLastPos(string sy="0", int tf=0, int op=-1, int mn=-1) {
  datetime t;
  int      i, k=OrdersHistoryTotal();

  if (sy=="" || sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (t<OrderCloseTime()) t=OrderCloseTime();
            }
          }
        }
      }
    }
  }
  return(iBarShift(sy, tf, t, True));
}
//=============================================================================//
void OpenPos(){
   double lot=LotsWork();
   double MA1=iMA(NULL,0,7,0,MODE_SMMA,PRICE_MEDIAN,1);
   double MA2=iMA(NULL,0,7,0,MODE_SMMA,PRICE_MEDIAN,2);
   double MA01=iMA(NULL,0,14,0,MODE_SMMA,PRICE_MEDIAN,1);
   double MA02=iMA(NULL,0,14,0,MODE_SMMA,PRICE_MEDIAN,2);
   double sl=0;
 if (useMart && isLossLastPos(Symbol(),-1,magic)) lot=NormLots(openLots*kLotUb);
  if(MA02<MA2 && MA01>MA1 && (NumberOfBarCloseLastPos()>0 || NumberOfBarCloseLastPos()==-1))
     {
      if (Stoploss3>0) sl=NormalizeDouble(Ask-Stoploss3*Point,Digits); else sl=0;
      int ticket=OrderSend(NULL,OP_BUY,lot,Ask,slip,sl,0,NULL,magic,0,clrBlue);
      if(ticket<0)
        {
         Print("OrderSend error #",GetLastError());
        }
      else {Print("Ask=",Ask); openPrice=Ask; typeOpen=OP_BUY;  openLots=lot; return; }
     }
  if(MA02>MA2 && MA01<MA1 && (NumberOfBarCloseLastPos()>0 || NumberOfBarCloseLastPos()==-1))
     {
      if (Stoploss3>0) sl=NormalizeDouble(Bid+Stoploss3*Point,Digits); else sl=0;
      ticket=OrderSend(NULL,OP_SELL,lot,Bid,slip,sl,0,NULL,magic,0,clrRed);
      if(ticket<0)
        {
         Print("OrderSend error #",GetLastError());
        }
      else {Print("Bid=",Bid); openPrice=Bid; typeOpen=OP_SELL; openLots=lot;}
     }
}
//+----------------------------------------------------------------------------+
bool isLossLastPos(string sy="", int op=-1, int mn=-1) {
   datetime t=0;
   int  j=-1;

   if (sy=="0") sy=Symbol();
   for (int i=0; i<OrdersHistoryTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
         if (OrderSymbol()==sy || sy=="") {
            if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
               if (op<0 || OrderType()==op) {
                  if (mn<0 || OrderMagicNumber()==mn) {
                     if (t<OrderCloseTime()) {
                        t=OrderCloseTime();
                        j=i;
                     }
                  }
               }
            }
         }
      }
   }
   if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderProfit()+OrderCommission()+OrderSwap()<0) return(true);
   }
   return(false);
}
//--------------------------------------------------------------------
//--------------------------------------------------------------------
double LotsWork(){
   int lotdigits=0;
   double maxLot=MarketInfo(Symbol(),MODE_MAXLOT);
   double minLot=MarketInfo(Symbol(),MODE_MINLOT);
   double lotstep=MarketInfo(Symbol(),MODE_LOTSTEP);
   double tradeLot=lotW;
   if (lotstep==0.01)lotdigits=2;
   if (lotstep==0.1)lotdigits=1;
   if (lotstep==1)lotdigits=0;
   if (lotW==0)
      tradeLot=NormalizeDouble(AccountBalance()/MarketInfo(Symbol(),MODE_MARGINREQUIRED)/(100.0/lotProc),lotdigits);
   tradeLot = NormalizeDouble(tradeLot,lotdigits);
   if (tradeLot > lotMax) tradeLot = lotMax;
   if (tradeLot > maxLot) tradeLot = maxLot;
   if (tradeLot < minLot)  tradeLot = minLot; 
   return(tradeLot);
}
//+------------------------------------------------------------------+
double NormLots(double wLot){
   int lotdigits=0;
   double maxLot=MarketInfo(Symbol(),MODE_MAXLOT);
   double minLot=MarketInfo(Symbol(),MODE_MINLOT);
   double lotstep=MarketInfo(Symbol(),MODE_LOTSTEP);
   double tradeLot=wLot;
   if (lotstep==0.01)lotdigits=2;
   if (lotstep==0.1)lotdigits=1;
   if (lotstep==1)lotdigits=0;
   tradeLot=NormalizeDouble(tradeLot,lotdigits);
   if (tradeLot > lotMax) tradeLot = lotMax;
   if(tradeLot > maxLot) tradeLot = maxLot;
   if(tradeLot < minLot)  tradeLot = minLot; 
   return(tradeLot);
}
//+------------------------------------------------------------------+
int CloseAll() {
   int count = 0;
   for (int trade = OrdersTotal() - 1; trade >= 0; trade--) {
      if (OrderSelect(trade, SELECT_BY_POS, MODE_TRADES))
       if (OrderSymbol()==Symbol() && (OrderType()==OP_BUY || OrderType()==OP_SELL) && (OrderMagicNumber()==magic || OrderMagicNumber()==magic+1)){
            ClosePosBySelect();;
         }
   }
   return (count);
}
//+---------------------------------------------------------------------------+
void ClosePosBySelect() {
  bool   fc;
  color  clClose;
  double ll, pa, pb, pp;
  int    dg=(int)MarketInfo(OrderSymbol(), MODE_DIGITS), err, it;

  if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
    for (it=1; it<=5; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
        Print("ClosePosBySelect():   ");
        break;
      }
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pa=MarketInfo(OrderSymbol(), MODE_ASK);
      pb=MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderType()==OP_BUY) {
        pp=pb; clClose=clrBlue;
      } else {
        pp=pa; clClose=clrRed;
      }
      ll=OrderLots();
      pp=NormalizeDouble(pp, dg);
      fc=OrderClose(OrderTicket(), ll, pp, 10, clClose);
      if (fc) { break;
      } else {
        err=GetLastError();
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
        Print("Error(",err,") Close ",err,", try ",it);
        Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
        Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
              "  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
        Sleep(1000*5);
      }
    }
  }
}
//--------------------------------------------------------------------
double Profit() {
   double prof = 0;
   for (int i=0; i<OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
       if (OrderSymbol()==Symbol() && (OrderType()==OP_BUY || OrderType()==OP_SELL) && (OrderMagicNumber()==magic || OrderMagicNumber()==magic+1)){
         prof=prof+OrderProfit()+OrderCommission()+OrderSwap();
       }
   }
   return (prof);
}
//+------------------------------------------------------------------+
int CountPos(int mag) {
   int count = 0;
   for (int i = OrdersTotal() - 1; i >= 0; i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol()==Symbol() && (OrderType()==OP_BUY || OrderType()==OP_SELL) && OrderMagicNumber()==mag){
            count++;
         }
   }
   return (count);
}
//+------------------------------------------------------------------+
